config/routes.rb
Rails.application.routes.draw do
  resources :students do 
    get "/check" => "students#check"
  end

  resources :teachers do 
    get "/change_password", to: "teachers#change_password"
  end

  resources :cells do 
    get "/students_personal_details" => 'cells#students_personal_details'
    get "/summary" => 'cells#summary'
  end
  
  resources :instructions
  resources :attendances
  
  resources :users
  resources :sessions, only: [:new, :create, :destroy]
  
  root 'cells#index'
  get '/' => 'cells#index'
  get '/login', to: 'sessions#new', as: 'login'
  get '/logout', to: 'sessions#destroy', as: 'logout'
  get '/search', to: 'application#searchByName'
  get "/admin", to: "application#admin"
  get "/cells_all", to: "cells#all"

end

app/models/student.rb
class Student < ActiveRecord::Base
    has_many :attendances
    has_many :cells, through: :attendances
    
    validates_presence_of :full_name, :gender, :date_birth
    validates :gender, inclusion: { in: %w(Nam Nữ), message: "have to be either Nam or Nữ" }
    
    validates_presence_of :date_baptism, if: :place_baptism?
    validates_presence_of :date_communion, if: :place_communion?
    validates_presence_of :date_confirmation, if: :place_confirmation?
    validates_presence_of :date_declaration, if: :place_declaration?
    
    validates_presence_of :street_name, if: :street_number? or :ward? or :district?
    
    validates :phone, format: { with: /\A\d+\z/, message: "only allows numbers" }, allow_blank: true
    validates :father_phone, format: { with: /\A\d+\z/, message: "only allows numbers" }, allow_blank: true
    validates :mother_phone, format: { with: /\A\d+\z/, message: "only allows numbers" }, allow_blank: true
    
    
    def name
        if christian_name?
            christian_name + " " + full_name
        else
            full_name
        end
    end
    
    def address
       self.street_number + " " + self.street_name + ", " + self.ward + ", " + self.district if self.street_name?
    end
    
    def result(cell)
       self.attendances.where(student_id: self.id, cell_id: cell.id).take.result 
    end
    
    def father_name
        if father_christian_name? && father_full_name?
            father_christian_name + " " + father_full_name
        elsif father_full_name?
            father_full_name
        end
    end
    
    def mother_name
        if mother_christian_name? && mother_full_name?
            mother_christian_name + " " + mother_full_name
        else
            mother_full_name
        end
    end
    
    def sort_param
        self.name.split(/\s+/).reverse!.join(" ").
        gsub(/[áàảãạăắặằẳẵâấầẩẫậ]/, 'a').
        gsub(/[íìỉĩị]/, 'i').
        gsub(/[úùủũụưứừửữự]/, 'u').
        gsub(/[éèẻẽẹêếềểễệ]/, 'e').
        gsub(/[óòỏõọôốồổỗộơớờởỡợ]/, 'o').
        gsub(/[đ]/, 'd').
        gsub(/[ýỳỷỹỵ]/, 'y').
        gsub(/[ÁÀẢÃẠĂẮẶẰẲẴÂẤẦẨẪẬ]/, 'A').
        gsub(/[ÍÌỈĨỊ]/, 'I').
        gsub(/[ÚÙỦŨỤƯỨỪỬỮỰ]/, 'U').
        gsub(/[ÉÈẺẼẸÊẾỀỂỄỆ]/, 'E').
        gsub(/[ÓÒỎÕỌÔỐỒỔỖỘƠỚỜỞỠỢ]/, 'O').
        gsub(/[Đ]/, 'D').
        gsub(/[ÝỲỶỸỴ]/, 'Y')
    end
end

app/controllers/students_controller.rb
class StudentsController < ApplicationController
  before_action :set_student, only: [:show, :edit, :update, :destroy]
  before_action :auth
  before_action :isAdmin, only: [:new, :create, :destroy, :check]
  
  # GET /students
  # GET /students.json
  def index
    @attendances = Attendance.joins(:cell).where("cells.year = ?", @current_year)
    
    respond_to do |format|
      format.html
      format.pdf do
        pdf = StudentsPdf.new(@arrays, @current_year)
        send_data pdf.render, filename: "Danh Sách Thiếu Nhi Năm Học #{@current_year_long}.pdf", type: "application/pdf", disposition: "inline"
      end
    end
  end

  # GET /students/1
  # GET /students/1.json
  def show
    @years = Cell.all.map{|c| c.year}.uniq.sort{|x,y| -(x <=> y)}
    @opts = Array.new
    Cell.all.sort_by{|c| c.sort_param}.each do |cell|
      if cell.year == @years[0] && cell.name != "Trưởng Ban" && cell.name != "Kỹ Thuật"
        @opts.push([cell.name, cell.id])
      end
    end
    
    respond_to do |format|
      format.html
      format.pdf do 
        pdf = StudentPdf.new(@student)
        send_data pdf.render , filename: "SYLL #{@student.name}.pdf", type: "application/pdf", disposition: "inline"
      end
    end
  end

  # GET /students/new
  def new
    @student = Student.new
  end

  # GET /students/1/edit
  def edit
  end

  # POST /students
  # POST /students.json
  def create
    @student = Student.new(student_params)

    respond_to do |format|
      if @student.save
        flash[:success] = 'Student was successfully created.'
        format.html { redirect_to @student }
        format.json { render :show, status: :created, location: @student }
      else
        format.html { render :new }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /students/1
  # PATCH/PUT /students/1.json
  def update
    respond_to do |format|
      if @student.update(student_params)
        flash[:success] = 'Student was successfully updated.'
        format.html { redirect_to @student }
        format.json { render :show, status: :ok, location: @student }
      else
        format.html { render :edit }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /students/1
  # DELETE /students/1.json
  def destroy
    @student.attendances.each do |att|
      att.destroy
    end

    @student.destroy
    respond_to do |format|
      flash[:success] = 'Student was successfully destroyed.'
      format.html { redirect_to students_url }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_student
      @student = Student.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def student_params
      params.require(:student).permit(
        :christian_name, 
        :full_name, 
        :gender, 
        :phone, 
        :date_birth, 
        :place_birth, 
        :date_baptism, 
        :place_baptism, 
        :date_communion, 
        :place_communion, 
        :date_confirmation, 
        :place_confirmation, 
        :date_declaration, 
        :place_declaration, 
        :street_number, 
        :street_name, 
        :ward, 
        :district, 
        :home_phone, 
        :area, 
        :father_christian_name, 
        :father_full_name, 
        :father_phone, 
        :mother_christian_name,
        :mother_full_name, 
        :mother_phone
      )
    end
end

app/helpers/students_helper.rb
module StudentsHelper
end

app/views/students/_form.html.erb
<%= form_for(@student) do |f| %>
  <% if @student.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@student.errors.count, "error") %> prohibited this student from being saved:</h2>

      <ul>
      <% @student.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

<p style="margin:10px"></p>

  <fieldset>
  <legend><h3>Thông Tin Cá Nhân</h3></legend>
    <div class="block">
      <div class="label">Tên Thánh:</div>
      <%= f.text_field :christian_name %>
    </div>
    
    <div class="block">
      <div class="label">Họ và Tên:</div>
      <%= f.text_field :full_name %>
    </div>
    
    
    <div class="block">
      <div class="label">Ngày Sinh:</div>
      <%= f.date_select :date_birth, {
        :start_year => 1900,
        :end_year => Date.today.year + 5,
        :include_blank => true, 
        :default => nil, 
        :use_two_digit_numbers => true, 
        :order => [:day, :month, :year], 
        :with_css_classes => true, 
        :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
      }%>
    </div>

    <div class="block">
      <div class="label">Nơi Sinh:</div>
      <%= f.text_field :place_birth %>
    </div>
    
    <div class="block">
      <div class="label">Giới Tính:</div>
      <%= f.select :gender, options_for_select(["Nam", "Nữ"], @student.gender), {
        :include_blank => true 
      }%>
    </div>
    
    <div class="block">
      <div class="label">Điện Thoại Cá Nhân:</div>
      <%= f.text_field :phone %>
    </div>
</fieldset>

<p style="margin:10px"></p>

<fieldset>
  <legend><h3>Ngày Bí Tích</h3></legend>

    <div class="block">
      <div class="label">Rửa Tội:</div>
            <%= f.date_select :date_baptism, {
              :start_year => 1900,
              :end_year => Date.today.year + 5,
              :include_blank => true, 
              :default => nil, 
              :use_two_digit_numbers => true, 
              :order => [:day, :month, :year], 
              :with_css_classes => true, 
              :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
            } %>
    </div>
    
    <div class="block">
      <div class="label">Nơi Rửa Tội:</div>
        <%= f.text_field :place_baptism %>
    </div>
    
    <div class="block">
      <div class="label">Rước Lễ:</div>
        <%= f.date_select :date_communion, {
          :start_year => 1900,
          :end_year => Date.today.year + 5,
          :include_blank => true, 
          :default => nil, 
          :use_two_digit_numbers => true, 
          :order => [:day, :month, :year], 
          :with_css_classes => true, 
          :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
        }%>
    </div>
      
    <div class="block">
      <div class="label">Nơi Rước Lễ:</div>
      <%= f.text_field :place_communion %>
    </div>
    
    <div class="block">
      <div class="label">Thêm Sức:</div>
        <%= f.date_select :date_confirmation, {
          :start_year => 1900,
          :end_year => Date.today.year + 5,
          :include_blank => true, 
          :default => nil, 
          :use_two_digit_numbers => true, 
          :order => [:day, :month, :year], 
          :with_css_classes => true, 
          :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
        }%>
    </div>

    <div class="block">
      <div class="label">Nơi Thêm Sức:</div>
      <%= f.text_field :place_confirmation %>
    </div>
    
    <div class="block">
      <div class="label">Tuyên Hứa:</div>
        <%= f.date_select :date_declaration, {
          :start_year => 1900,
          :end_year => Date.today.year + 5,
          :include_blank => true, 
          :default => nil, 
          :use_two_digit_numbers => true, 
          :order => [:day, :month, :year], 
          :with_css_classes => true, 
          :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
        }%>
    </div>

    <div class="block">
      <div class="label">Nơi Tuyên Hứa:</div>
      <%= f.text_field :place_declaration %>
    </div>
</fieldset>

<p style="margin:10px"></p>

<fieldset>
  <legend><h3>Địa Chỉ Nhà</h3></legend>
  
  <div class="block">
    <div class="label">Số Nhà:</div>
    <%= f.text_field :street_number %>
  </div>
  <div class="block">
    <div class="label">Đường:</div>
    <%= f.text_field :street_name %>
  </div>
  <div class="block">
    <div class="label">Phường/Xã:</div>
    <%= f.text_field :ward %>
  </div>
    <div class="label">Quận/Huyện:</div>
      <%= f.text_field :district %>
  </div>
  
  <div class="block">
    <div class="label">Xóm Giáo:</div>
    <%= f.text_field :area %>
  </div>
</fieldset>

<p style="margin:10px"></p>

<fieldset>
  <legend><h3>Thông Tin Cha Mẹ</h3></legend>
    <div class="block">
      <div class="label">Tên Thánh Cha:</div>
      <%= f.text_field :father_christian_name %>
    </div>
    
    <div class="block">
      <div class="label">Họ Tên Cha:</div>
      <%= f.text_field :father_full_name %>
    </div>

    <div class="block">
      <div class="label">Điện Thoại Cha:</div>
      <%= f.text_field :father_phone %>
    </div>      

    <div class="block">
    </div>      
        
    <div class="block">
      <div class="label">Tên Thánh Mẹ:</div>
      <%= f.text_field :mother_christian_name %>
    </div>
    
    <div class="block">
      <div class="label">Họ và Tên Mẹ:</div>
      <%= f.text_field :mother_full_name %>
    </div>

    <div class="block">
      <div class="label">Điện Thoại Mẹ:</div>
      <%= f.text_field :mother_phone %>
    </div>
</fieldset>

  <div class="actions" style="padding-top:10px">
    <%= f.submit "Cập Nhật", :class =>"button" %>
  </div>
<% end %>

app/views/students/_info_table.html.erb
<% groups = @attendances.group_by(&:result).sort.each do |key, group| %>
  <div style="text-align: right; padding-top: 10px; font-size: 11px"><%= key + ": " + group.count.to_s %></div>
  <table class="table table-striped">
    <thead>
      <tr>
        <th style='width: 20px'>STT</th>
        <th style='width: 230px'>Tên Thánh - Họ và Tên</th>
        <th style='width:  80px'>Ngày Sinh</th>
        <th style='width: 340px'>Địa Chỉ</th>
        <th style='width:  80px'>ĐT Cha</th>
        <th style='width:  80px'>ĐT Mẹ</th>
        <th style='width:  73px'>Lớp</th>
        <th style='width:  73px'>Kết Quả</th>
      </tr>
    </thead>
    <tbody>
      <% group.sort_by{|a| a.student.sort_param}.each_with_index do |attendance, index| %>
        <% student = attendance.student %>
        <% cell = attendance.cell %>
        <% result = attendance.result %>
        
        <tr class = table-row>
          <td style='width: 20px'><%= index+1 %></td>
          <td style='width: 230px'><div class ='btn-link'><%= link_to student.name, student %></div></td>
          <td style='width:  80px'><%= student.date_birth.strftime("%d-%m-%Y") %></td>
          <td style='width: 340px'><%= student.address %></td>
          <td style='width:  80px'><%= student.father_phone %></td>
          <td style='width:  80px'><%= student.mother_phone %></td>
          <td style='width:  73px'><%= link_to cell.name, cell %></td>
          <td style='width:  73px'><%= link_to result, edit_attendance_path(attendance) %></td> 
        </tr>
      <% end %>
    </tbody>
  </table>
<% end %>

app/views/students/edit.html.erb
<h1>Cập Nhật Thông Tin Thiếu Nhi </h1>

<%= render 'form' %>
<%= link_to 'Quay Lại', :back, :class => "button" %>
<%= link_to 'Xóa', @student, method: :delete, data: { confirm: 'Xóa hết thông tin và Hành Trình Thiêng Liêng của thiếu nhi? Nên cập nhật thông tin thay vì xóa. Are you sure?' }, :class => "button-caution" %>

app/views/students/index.html.erb
<h1>Danh Sách Thiếu Nhi Năm Học <%= @current_year_long %></h1>
<h4>Số Lượng : <%= @attendances.count %></h4>

<%= render 'info_table' %> 

app/views/students/new.html.erb
<h1>Sơ Yếu Lý Lịch</h1>

<%= render 'form' %>

<%= link_to 'Quay Lại', :back, :class => "button" %>

app/views/students/show.html.erb
<h1>Sơ Yếu Lý Lịch</h1>


<p style="margin: 10px"></p>
<fieldset>
  <legend><h3>Thông Tin Cá Nhân</h3></legend>
    <div class="block">
      <div class="label">Tên Thánh - Họ và Tên:</div>
      <strong><%= @student.name %></strong>
    </div>
    
    <div class="block">
      <div class="label">Giới Tính:</div>
      <strong><%= @student.gender %></strong>
    </div>
  
    <div class="block">
      <div class="label">Ngày Sinh:</div>
      <strong><%= @student.date_birth.strftime("%d-%m-%Y") %></strong>
      <% if @student.place_birth? %>
        <div style="display: inline-block; width: 30px; text-align: center">tại</div>
        <strong><%= @student.place_birth %></strong>
      <% end %>
    </div>
    
    <div class="block">
      <div class="label">Điện Thoại Cá Nhân:</div>
      <strong><%= @student.phone %></strong>
    </div>
</fieldset>

<p style="margin: 10px"></p>
  
<fieldset>
  <legend><h3>Ngày Bí Tích</h3></legend>

    <div class="block">
      <div class="label" style="width:80px">Rửa Tội:</div>
      <strong><%= @student.date_baptism.strftime("%d-%m-%Y") if @student.date_baptism? %></strong>
      <% if @student.place_baptism? %>
        <div style="display: inline-block; width: 30px; text-align: center">tại</div>
        <strong><%= @student.place_baptism %></strong>
      <% end %>
    </div>
    
    <div class="block">
      <div class="label" style="width:80px">Rước Lễ:</div>
      <strong><%= @student.date_communion.strftime("%d-%m-%Y") if @student.date_communion? %></strong>
      <% if @student.place_communion? %>
        <div style="display: inline-block; width: 30px; text-align: center">tại</div>
        <strong><%= @student.place_communion %></strong>
      <% end %>
    </div>
    
    <div class="block">
      <div class="label" style="width:80px">Thêm Sức:</div>
      <strong><%= @student.date_confirmation.strftime("%d-%m-%Y") if @student.date_confirmation? %></strong>
      <% if @student.place_confirmation? %>
        <div style="display: inline-block; width: 30px; text-align: center">tại</div>
        <strong><%= @student.place_confirmation %></strong>
      <% end %>
    </div>
    
    <div class="block">
      <div class="label" style="width:80px">Tuyên Hứa:</div>
      <strong><%= @student.date_declaration.strftime("%d-%m-%Y") if @student.date_declaration? %></strong>
      <% if @student.place_declaration? %>
        <div style="display: inline-block; width: 30px; text-align: center">tại</div>
        <strong><%= @student.place_declaration %></strong>
      <% end %>
    </div>
</fieldset>

<p style="margin: 10px"></p>

<fieldset>
  <legend><h3>Địa Chỉ Nhà</h3></legend>
  
  <div>
    <div class="label">Địa Chỉ:</div>
    <strong><%= @student.address %></strong>
  </div>
  <div class="block">
    <div class="label">Xóm Giáo:</div>
    <strong><%= @student.area %></strong>
  </div>
</fieldset>

<p style="margin: 10px"></p>

<fieldset>
  <legend><h3>Thông Tin Cha Mẹ</h3></legend>
    <div class="block">
      <div class="label">Tên Thánh - Họ và Tên Cha:</div>
      <strong><%= @student.father_name %></strong>
    </div>

    <div class="block">
      <div class="label">Điện Thoại Cha:</div>
      <strong><%= @student.father_phone %></strong>
    </div>      
    
    <div class="block">
      <div class="label">Tên Thánh - Họ và Tên Mẹ:</div>
      <strong><%= @student.mother_name %></strong>
    </div>

    <div class="block">
      <div class="label">Điện Thoại Mẹ:</div>
      <strong><%= @student.mother_phone %></strong> 
    </div>      
</fieldset>
<%= link_to 'Chỉnh Sửa', edit_student_path(@student), :class => "button" %>
<%= link_to "In Sơ Yếu Lý Lịch", student_path(format: "pdf"), :class => "button" %>

<div class="divider"></div> 

<h1><center>Hành Trình Thiêng Liêng</center></h1>

<table>
  <thead>
    <tr>
      <th style="width: 200px; font-size: 18px">Năm Học</th>
      <th style="width: 200px; font-size: 18px">Lớp</th>
      <th style="width: 200px; font-size: 18px">Kết Quả</th>
    </tr>
  </thead>
  <tbody>
    <% @student.cells.sort_by {|cell| cell.year}.each do |cell| %>
    <tr class="table-row">
      <td style="width: 200px; font-size: 14px"><%= cell.long_year %></td>
      <td style="width: 200px; font-size: 14px"><%= link_to cell.name, cell %></td>
      <td style="width: 200px; font-size: 14px"><%= link_to @student.result(cell), edit_attendance_path(Attendance.where(student_id: @student.id, cell_id: cell.id).take.id) %></td>
    </tr>
    <% end %>
    
    <tr class="table-row">
      <td id="form" style="display: none" colspan="3">
        <% @attendance = Attendance.new %>
        <%= form_for(@attendance) do |f| %>
          <% if @attendance.errors.any? %>
            <div id="error_explanation">
              <h2><%= pluralize(@attendance.errors.count, "error") %> prohibited this attendance from being saved:</h2>

              <ul>
              <% @attendance.errors.full_messages.each do |message| %>
                <li><%= message %></li>
              <% end %>
              </ul>
            </div>
          <% end %>
          <select id="year_combobox" onchange="changeCell()">
            <% selected_year = @years[0] %>
            <% @years.each do |year| %>
              <option value="<%=year%>"><%= year.to_s + " - " + (year.to_i+1).to_s %></option>
            <% end %>
          </select>
          <%= f.hidden_field :student_id, :value => @student.id %>
          <%= f.hidden_field :result, :value => "Đang Học" %>
          <%= f.select :cell_id, options_for_select(@opts), :id => 'cell_id' %>
          <%= f.submit "Thêm Lớp Mới" %>
        <% end %>
      </td>
    </tr>
  </tbody>
</table>

<center><button id="btn" onClick="showForm()" class="button" style="width:600px">Thêm Lớp Mới</button></center>

<script>
  function showForm() {
    document.getElementById("btn").style.display = "none";
    document.getElementById("form").style.display = "table-cell";
  }
  
  function changeCell() {
    var e = document.getElementById("year_combobox");
    var selected = e.options[e.selectedIndex].value;

    
    //Create array of options to be added
    var hash = {};
    var keys = [];
    
    <% Cell.all.sort_by{|c| c.sort_param}.each do |cell| %>
    if(selected == "<%= cell.year %>" && "<%= cell.name %>" != "Trưởng Ban" && "<%= cell.name %>" != "Kỹ Thuật") {
      hash[<%= cell.id %>] = "<%= cell.name %>";
      keys.push(<%= cell.id %>);
    }
    <% end %> 
    
    var list = document.getElementById("attendance_cell_id");
    list.options.length = 0;
    
    //Create and append the options
    for (var i = 0; i < keys.length; i++) {
        var option = document.createElement("option");
        option.value = keys[i];
        option.text = hash[keys[i]];
        list.appendChild(option); 
    }
    
  }
</script>